# absolu.py 
# essai de trouver la config absolu
# version 27/10/17 : on ajoute arguments (pins, lettre, msg_key)
import sys
import getopt
from m209 import *

#===============================================================
Wheels = [
   "ABCDEFGHIJKLMNOPQRSTUVWXYZ",
   "ABCDEFGHIJKLMNOPQRSTUVXYZ",
   "ABCDEFGHIJKLMNOPQRSTUVX",
   "ABCDEFGHIJKLMNOPQRSTU",
   "ABCDEFGHIJKLMNOPQRS",
   "ABCDEFGHIJKLMNOPQ"
]
#===============================================================
def l2n( letter ):
    return "ABCDEFGHIJKLMNOPQRSTUVWXYZ".find( letter )

def n2l( number ):
    return "ABCDEFGHIJKLMNOPQRSTUVWXYZ"[ number ]

def newPins( tb ):
    pins = ""
    for i in range(6):
        pins +=  thePins[i][tb[i]:] + thePins[i][0:tb[i]]
    return pins

def printKey( pins ):
    roue = []
    roue.append( pins[:26] )
    roue.append( pins[26:51] )
    roue.append( pins[51:74] )
    roue.append( pins[74:95] )
    roue.append( pins[95:114] )
    roue.append( pins[114:] )
    ch = ""
    for i in range(6):
        for j in range(len(Wheels[i])):
            if roue[i][j] == "1":
                car = Wheels[i][j]
            else:
                car = "_"
            ch += car
        ch += "\n"
    return ch    

#======================================
def usage():
    print "usage:"
    print "  -h         Help"
    print "  -c cipher  Cipher"
    print "  -p plain   Plain text"
    print "  -E key     External Key form Indicator Groups"
    print "  -l letter  The letter ciphered twelve times"
    print "  -P pins    The Pins (101010111....00101)"
    print "  -L lugs    The lugs (ex: 1:5:4:13:2:7)"
    print "  -O overlaps    The overlaps (ex: 0:0:1...:1:1)"
    print "  -d         Debug"
#======================================
#--------------------------------------------------
try:
  opts, args = getopt.getopt(sys.argv[1:],
    "hE:l:P:L:O:dc:p:", ["help", "exterior=", "letter=","pins=",
    "lugs=", "overlaps=", "debug", "cipher=", "plain="])
except getopt.GetoptError as err:
  # print help information and exit:
  print sys.argv[0],": ", str(err) # option -a not recognized"
  usage()
  sys.exit(2)

L12 = "A" 
Ext = "AAAAAA"
CH_LUGS = ""
PINS = ""
thePins = []
CH_OVER = ""
CIPHER = ""
PLAIN  = ""
DEBUG = False

for o, a in opts:
  if o == "-d":
    DEBUG = True
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  elif o in ("-E", "--exterior"):
    Ext = a
  elif o in ("-l", "--letter"):
    L12 = a 
  elif o in ("-L", "--lugs"):
    CH_LUGS = a
  elif o in ("-O", "--overlaps"):
    CH_OVER = a
  elif o in ("-P", "--pins"):
    PINS = a
  elif o in ("-c", "--cipher"):
    CIPHER = a
  elif o in ("-p", "--plain"):
    PLAIN = a
  else:
    assert False, "unhandled option"
#if PINS == ""  or CH_LUGS == "" or CH_OVER == "":
#  print "Lugs or Overlaps or Pins are missing"
#  usage()
#  sys.exit(1)

#--------------------------------------------------
thePins = []
thePins.append( PINS[:26] )
thePins.append( PINS[26:51] )
thePins.append( PINS[51:74] )
thePins.append( PINS[74:95] )
thePins.append( PINS[95:114] )
thePins.append( PINS[114:] )

print "Plain: ", PLAIN
print "Cipher:", CIPHER
print "External Key from Indicator Groups: ", Ext
print "Letter: ", L12[0]
print "Lugs: ", CH_LUGS
print "Pins: ", PINS
print printKey( PINS )
print "Overlaps: ", CH_OVER
print "Debug: ", DEBUG 
#=================================================
c = Hagelin( "Z", DEBUG)
c.setLugs(map(int,CH_LUGS.split(":")))
c.setOver(map(int,CH_OVER.split(":")))
c.setAllPinsAllW(PINS)

#=== on essaye toute les cles
for ii in range(26):
 print ii
 for jj in range(25):
  for kk in range(23):
   for ll in range(21):
    for mm in range(19):
     for nn in range(17):

      pinsAbs = newPins( [ii,jj,kk,ll,mm,nn] )
      c.setAllPinsAllW( pinsAbs )
      c.setExternalKey( Ext )
      dechif = ""
      for i in range(12):
        car = c.cipher( L12 )
        dechif += car

      idx = 0
      KEYEXTERN = ""
      for r in range(6):
        while (idx < 12):
           lettre = dechif[ idx ]
           if lettre in Wheels[r]: 
              break
           else:
              idx = idx + 1
        if idx == 12: break
        KEYEXTERN += lettre
        idx = idx + 1  
      if idx == 12: continue

      c.setExternalKey(KEYEXTERN)
      plainGiven = ""
      for i in range(len(CIPHER)):
        car = c.cipher( CIPHER[i] )
        plainGiven += car
      
      if plainGiven == PLAIN:
        print ii,jj,kk,ll,mm,nn, KEYEXTERN,
        print pinsAbs
        print printKey( pinsAbs )

